//+------------------------------------------------------------------+
//|                                                           XO.mq4 |
//|                                   Original Author SHARIPOV AINUR |
//|               Conversion to MT4 and modification only adoleh2000 |
//|                                                 additions mladen |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Green
#property indicator_color2     Red

//
//
//
//
//

extern double BoxSixe = 15;

//
//
//
//
//

double ExtMapBuffer1[]; // XO up
double ExtMapBuffer2[]; // Xo down
double Hi[];
double Lo[];
double no[];
double kr[];
int    Kir;



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);   
      SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,no);
      SetIndexBuffer(3,kr);
      SetIndexBuffer(4,Hi);
      SetIndexBuffer(5,Lo);
   SetIndexEmptyValue(2,0.00);
   SetIndexEmptyValue(3,0.00);
   SetIndexEmptyValue(4,0.00);
   SetIndexEmptyValue(5,0.00);
   SetIndexLabel(0,"XO Up");
   SetIndexLabel(1,"XO Down");

   //
   //
   //
   //
   //
      
   IndicatorShortName("XO ("+DoubleToStr(BoxSixe,2)+")");
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   double cur,valuel,valueh;
   int    counted_bars=IndicatorCounted();
   int    i,limit;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         int digit  = MarketInfo(Symbol(),MODE_DIGITS);
         int pipMultiplier =1;
            if (digit==3 || digit==5)
                  pipMultiplier=10;         
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0; i--)
   {         
      if (Kir<1) { Hi[i+1]=Close[i]; Lo[i+1]=Close[i]; Kir =1; }

      //
      //
      //
      //
      //
      
      cur   = Close[i];
      Hi[i] = Hi[i+1];
      Lo[i] = Lo[i+1];
      no[i] = no[i+1];
      kr[i] = kr[i+1];

         if (cur > (Hi[i]+BoxSixe*pipMultiplier*Point)) 
         {
            Hi[i] = cur;
            Lo[i] = cur-BoxSixe*pipMultiplier*Point;
            kr[i] = kr[i+1]+1;
            no[i] = 0;
         }
         if (cur < (Lo[i]-BoxSixe*pipMultiplier*Point)) 
         {
            Lo[i] = cur;
            Hi[i] = cur+BoxSixe*pipMultiplier*Point;
            no[i] = no[i+1]+1;
            kr[i] = 0;
         }

      //
      //
      //
      //
      //
      
      valueh=kr[i];
      valuel=0-no[i];
         ExtMapBuffer1[i]=valueh;
         ExtMapBuffer2[i]=valuel;
   }
   return(0);
}

